package com.ruansee.macall.testwebview.utils;

import com.base.code.binary.Base64;

import java.security.SecureRandom;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

/**
 * created by:   Macall
 * create time:  2022/11/1 9:42
 * copyright:    @ruansee.com
 * Describe:
 */
public class JiaMi {

    /**
     * 根据 key 加密 data ， 并将加密后的数据进行Base64转码
     * @param data      待加密的数据
     * @param id        id
     * @param secret    秘钥
     * @return          Base64字符
     */
    public static String desCrypto(byte[] data, String id,String secret) {
        return desCrypto(data,String.format("%s:%s",id,secret));
    }

    /**
     * 根据 key 加密 data ， 并将加密后的数据进行Base64转码
     * @param data      待加密的数据
     * @param key       加密的KEY
     * @return          Base64字符
     */
    private static String desCrypto(byte[] data, String key) {
        try{
            SecureRandom random = new SecureRandom();
            DESKeySpec desKey = new DESKeySpec(key.getBytes());
            //创建一个密匙工厂，然后用它把DESKeySpec转换成
            SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
            SecretKey securekey = keyFactory.generateSecret(desKey);
            //Cipher对象实际完成加密操作
            Cipher cipher = Cipher.getInstance("DES");
            //用密匙初始化Cipher对象
            cipher.init(Cipher.ENCRYPT_MODE, securekey, random);
            //现在，获取数据并加密
            //正式执行加密操作
            byte[] bytes = cipher.doFinal(data);
            //进行Base64转码
            return Base64.encodeBase64String(bytes);
        }catch(Throwable e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * DES 解密
     * @param data          加密后的字符
     * @param key           key
     * @return              解密后的数据
     * @throws Exception    异常信息
     */
    private static byte[] decrypt(byte[] data, String key) throws Exception {
        // DES算法要求有一个可信任的随机数源
        SecureRandom random = new SecureRandom();
        // 创建一个DESKeySpec对象
        DESKeySpec desKey = new DESKeySpec(key.getBytes());
        // 创建一个密匙工厂
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
        // 将DESKeySpec对象转换成SecretKey对象
        SecretKey securekey = keyFactory.generateSecret(desKey);
        // Cipher对象实际完成解密操作
        Cipher cipher = Cipher.getInstance("DES");
        // 用密匙初始化Cipher对象
        cipher.init(Cipher.DECRYPT_MODE, securekey, random);
        // 真正开始解密操作
        return cipher.doFinal(data);
    }

    /**
     * DES 解密
     * @param encryptData          加密后的字符
     * @param key           key
     * @return              解密后的数据
     * @throws Exception    异常信息
     */
    public static String decrypt(String encryptData, String key) throws Exception {
        byte[] data = Base64.decodeBase64(encryptData);
        byte[] decrypt = decrypt(data, key);
        return new String(decrypt,"UTF-8");
    }

    /**
     * DES 解密
     * @param encryptData   加密后的字符
     * @param id            ID
     * @param secret        秘钥
     * @return              解密后的数据
     * @throws Exception    异常信息
     */
    public static String decrypt(String encryptData, String id,String secret) throws Exception {
        byte[] data = Base64.decodeBase64(encryptData);
        byte[] decrypt = decrypt(data, String.format("%s:%s",id,secret));
        return new String(decrypt,"UTF-8");
    }


}
